estep <-
function(theta, y) {

        if (is.vector(y)){
          y<-matrix(y,ncol=1)
        }
	pi = theta$pi
        K = length(pi)
        n = dim(y)[1]
        d = dim(y)[2]
        mu = as.matrix(theta$mu,nrow=K)
       	W = w= matrix(0, nrow=n, ncol=K)
        
	if (theta$family %in% c("Gaussian","1dGaussian", "Cauchy")){
           Sigma = theta$Sigma
         # if (d==1){theta$family="1dGaussian"}
        }         
     
      for (i in 1:n) {
        for (k in 1:K){ 
          w[i,k] =  pi[k] *  switch(theta$family,
                                    "1dGaussian"= dnorm(y[i,], mean=mu[k,], sd=sqrt(Sigma[[k]])),
                                    "Gaussian"= mvtnorm::dmvnorm(y[i,], mean=mu[k,], sigma=Sigma[[k]]),
                                    "Poisson"=  dpois(y[i,], lambda=mu[k]),
                                   # "Cauchy"=dcauchy(y[i], location=mu[k], scale=Sigma[[k]])
                                  )                
        }
      }  
      sumK <- apply(w,1,sum) 
      W <- sweep(w,1,sumK,FUN="/") 
      return (W)
}



