



kboxplot<-function(data,W=NULL,k,type="default",cen=0, colbox,xlim,ylim,col,xlab,ylab,xaxt,main=type){
   if (type=="two" && k!=2){
    k<-2; W<- NULL
    warning("k forced to be equal to 2.")
  }  
  if(is.null(W)){
    W<-EM(data,k)$W}
  if(missing(k)){
    k<-dim(W)[2]
  }
 
  d<-Max(W)
  p<-colMeans(W)
  weight_Q<-WQ(W,data)
  wq<-weight_Q$wq
  l<-weight_Q$L
  G<- weight_Q$G
  if(type=="default"){
    
    y2<-rep(cen,length(data))
    if(missing(xlim)){
      xlim<-cen+c(-1,1)
    }
    if(missing(ylim)){
      ylim<-c(min(data),max(data))+c(-1,1)*.1
    }
    if(missing(col)){
      col<-rainbow(k)
    }
    if(missing(colbox)){
      colbox<-"white"
    }
    if(missing(xlab)){
      xlab<-" "
    }
    if(missing(ylab)){
      ylab<-" "
    }
   
    if(missing(xaxt)){
      xaxt<-"s"
    }
    plot(y2,data,pch=20,cex=0.5,xlab=xlab,ylab=ylab,main=main,xlim=xlim,ylim=ylim,xaxt=xaxt)
    par(new=TRUE)
    for ( i in 1:k){
      y1<-rep(cen,l[i])
      plot(y1,data[G[i,1:l[i]]],col=col[i],pch=20,cex=0.5,xlim=xlim,ylim=ylim,xlab=" ",ylab=" ",main=" ",axes=FALSE)
      rect(cen-p[i], wq[i,3], p[i]+cen, wq[i,1], col=colbox,border = col[i],lty=i)
      segments(cen-p[i], wq[i,2], p[i]+cen, wq[i,2],col=col[i],lty=i)
      par(new=TRUE)
    } }else{if(type=="plain"){
      
      y2<-rep(cen,length(data))
      if(missing(xlim)){
        xlim<-cen+c(-1,1)
      }
      if(missing(ylim)){
        ylim<-c(min(data),max(data))+c(-1,1)*.1
      }
      if(missing(col)){
        col<-rainbow(k)
      }
      if(missing(colbox)){
        colbox<-"white"
      }
      if(missing(xlab)){
        xlab<-" "
      }
      if(missing(ylab)){
        ylab<-" "
      }
     
      if(missing(xaxt)){
        xaxt<-"s"
      }
      plot(0,0,pch=20,cex=0.5,xlab=xlab,ylab=ylab,main=main,xlim=xlim,ylim=ylim,xaxt=xaxt)
      segments(cen,min(data), cen,max(data),col="black")
      segments(cen-0.1,min(data), cen+0.1,min(data),col="black")
      segments(cen-0.1,max(data), cen+0.1,max(data),col="black")
      for ( i in 1:k){
        rect(cen-p[i], wq[i,3], p[i]+cen, wq[i,1],col=colbox,border = col[i],lty=i)
        segments(cen-p[i], wq[i,2], p[i]+cen, wq[i,2],col=col[i],lty=i)
      }}else{  
       
        y2<-rep(cen,length(data))
        if(missing(xlim)){
          xlim<-cen+c(-1,1)
        }
        if(missing(ylim)){
          ylim<-c(min(data),max(data))+c(-1,1)*.1
        }
        if(missing(col)){
          col<-rainbow(k)
        }
        if(missing(colbox)){
          colbox<-"white"
        }
        if(missing(xlab)){
          xlab<-" "
        }
        if(missing(ylab)){
          ylab<-" "
        }
       
        if(missing(xaxt)){
          xaxt<-"s"
        }
        plot(y2,data,pch=20,cex=0.5,xlab=xlab,ylab=ylab,main=main,xlim=xlim,ylim=ylim,xaxt=xaxt)
        Lines(data,k,W,cen,col,type)
        par(new=TRUE)
        for ( i in 1:k){
          y1<-rep(cen,l[i])
          plot(y1,data[G[i,1:l[i]]],col=col[i],pch=20,cex=0.5,xlim=xlim,ylim=ylim,xlab=" ",ylab=" ",main=" ",axes=FALSE)
          rect(cen-p[i], wq[i,3], p[i]+cen, wq[i,1],col=colbox,border = col[i],lty=i)
          segments(cen-p[i], wq[i,2], p[i]+cen, wq[i,2],col=col[i],lty=i)
          par(new=TRUE) }}}
  
  par(new=FALSE)
}
