shortruns <-
function(y, K, init="random", family="Gaussian",   maxit=50, threshold = 10,   lambda=1, verbose=TRUE, plot=FALSE){
  shortfit<-list()
  liks<-c()
  it<-0
  j<-1
  while (it<maxit){
   
     shortfit[[j]]<- EM(y, K, init="random",  family=family, iter=maxit-it, threshold=threshold, lambda=lambda, plot=plot, verbose=verbose)
     theta<- shortfit[[j]]
   
     liks[j]<-tail(theta$ll,n=1)
     it<-it+theta$iter
     j<-j+1
  }
 # print(j)
  s<-which(liks==max(liks))[1]
  return(shortfit[[s]])
}
