cauchSim<-function(theta){
  pi<-theta$pi
  K<-length(pi)
  mu<- as.vector(theta$mu)
  gam<-theta$Sigma
  
  x <-runif(1)
  sim<-0
  cpi<-cumsum(pi) 
  k <-1
  if (length(gam)==1){gam<-rep(gam,K)}
  while (x>cpi[k]){
    k<-k+1
  }    
  sim <- rcauchy(n=1,location=mu[k],scale=gam[[k]])
  return(sim)
}


# n observations
cauchSimN <-
  function(n, theta) {
    s = NULL
    for (i in 1:n) {
      s = rbind(s, cauchSim(theta))
    }
    return (s)
  }


