gaussSim <-
function(theta) {
	
	K = length(theta$pi)
	
	p = theta$pi
	m = theta$mu
	Sigma = theta$Sigma
	x   = runif(1)
	sim = 0
	cpi = cumsum(p)
	k   = 1
	while (x>cpi[k]) {
		k = k + 1
	}
	
	sim = mvtnorm::rmvnorm(n=1, mean=m[k,], sigma=Sigma[[k]]) 

	return (sim)
}


gaussSimN <-
  function(n, theta) {
    s = NULL
    for (i in 1:n) {
      s = rbind(s, gaussSim(theta))
    }
    return (s)
  }



