poisSim <-
function(theta) {
	
	K = length(theta$pi)
	
	p = theta$pi
	m = theta$mu
	x   = runif(1)
	sim = 0
	cpi = cumsum(p)
	k   = 1
	while (x>cpi[k]) {
		k = k + 1
	}
	
	sim = rpois(1, m[k]) 

	return (sim)
}


poisSimN <-
  function(n, theta) {
    s = NULL
    for (i in 1:n) {
      s = c(s, poisSim(theta))
    }
    return (s)
  }
