wtSigma <-
function(s, wk, K) {

	p = list()

	for (i in 1:K) {
		p[[i]] = matrix(0, dim(s[[1]])[1], dim(s[[1]])[2])
		for (j in 1:K) {
			p[[i]] = p[[i]] + wk[i,j] * s[[j]]
		}
	}

	return (p)
}


Max<-function(x){
  n<-dim(x)[1]
  M<-rep(0,n)
  for(i in 1:n){
    M[i]<-max(x[i,])}
  return(M)
}

weighted.quantile.top<-function(dat, weights, p){
  weights<-weights[order(dat)]
  n<-length(weights)
  dat<-sort(dat)
  q<- sum(weights)*p
  m<-w<-0
  for (i in n : 1){ w<- w+weights[i]
  if (w >= q) {m<- dat[i] ; break}
  }
  m
}

weighted.quantile <- function(dat, weights, p){
  weights <- weights[order(dat)]
  dat     <- sort(dat)
  q       <- sum(weights)*p
  m <- w  <-0
  for (i in 1 : length(weights)){
    w <- w+weights[i]
    if (w >= q) {m<- dat[i] ; break}
  }
  m
}


WQ<-function(x,y){
  p<-c(0.25,0.5,0.75)
  z<-Max(x)
  l<-length(y)
  n<-dim(x)[2]
  m<-length(p)
  wq<-matrix(0,n,m)
  G<-matrix(0,n,l)
  M<-matrix(0,n,l)
  L<-rep(0,n)
  for(i in 1:n){
    U<-x[,i][x[,i]==z]
    D<-which(x[,i]==z)
    if(length(D)!=0){
      L[i]<-length(D)
      G[i,1:L[i]]<-D
      M[i,1:L[i]]<-U
      for(j in 1:m){
        wq[i,j]<- weighted.quantile.top(y[D],U, p[j])}} }
  return(list("G"=G, "wq"=wq,"L"=L,"M"=M))
}

Lines<-function(dat,z,WIK,cen,coll,type){
  p<-c(0.25,0.5,0.75)
  if(type=="two"){
    weight_Q<-WQ(WIK,dat)
    if(z==2){
      wq<- weight_Q$wq
      R<-dat
      r<-length(R)
      M<-c()
      for(j in 1:r)
      {
        M[j]<-which(dat==R[j])[1]}
      Wights<-WIK[M,]
      for(s in 1:r)
      {
        segments(cen-(Wights[s,1]), R[s],cen, R[s],col=coll[1],lty=1)
        segments(cen, R[s],cen+(Wights[s,2]), R[s],col=coll[2],lty=2)}}
  }
  if(type=="full"){ 
    weight_Q<-WQ(WIK,dat)
    G<- weight_Q$G
    L<- weight_Q$L
    M<- weight_Q$M
    R<-dat
    for(d in 1:z){
      
      Wights<-M[d,1:L[d]]
      for(s in 1:L[d]){
        if(length( R[G[d,s]])!=0){
          segments(cen,R[G[d,s]],cen+Wights[s],R[G[d,s]],col=coll[d],lty=d)}}
    }}}


