\name{init}
\alias{init}
\alias{shortruns}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Initializing the EM algorithm
}
\description{
Functions to initialize the EM algorithm.
}
\usage{
init(y, K, type = "quantile", tol=0.5,  ...)
shortruns(y, K, init = "random", family = "Gaussian", maxit = 50, 
    threshold = 10, lambda = 1, verbose = TRUE, plot = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{y}{
a univariate or multivariate data set.
}
  \item{K}{
the number of components.
}
  \item{type}{
type of starting points. Includes "random" (randomly chosen from the
data), "scatter" (uniformly sampled from the _support_ of the data),
"quantile" (quantile-based), "shortruns" (short runs of EM), "gq" (based
on Gauss Quadrature points).
}
 \item{tol}{
only relevant for \code{type="gq"}. Scales Gaussian Quadrature points
inwards or outwards by the factor \code{tol}.
}

 \item{init}{
%%     ~~Describe \code{type} here~~
}
 \item{family}{
%%     ~~Describe \code{type} here~~
}
\item{maxit}{
%%     ~~Describe \code{type} here~~
}
\item{threshold}{
%%     ~~Describe \code{type} here~~
}
\item{lambda}{
%%     ~~Describe \code{type} here~~
}
\item{verbose}{
%%     ~~Describe \code{type} here~~
}
\item{plot}{
%%     ~~Describe \code{type} here~~
}
  \item{\dots}{
%%     ~~Describe \code{\dots} here~~
}
}


\author{
J. Einbeck and D. Bonetti
}



%\seealso{

%% ~Make other sections like Warning with \section{Warning }{....} ~

  
%% ~~objects to See Also as \code{\link{help}}, ~~~
%}
%\examples{
%
%}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
